<template>
  <div class="container">
    <el-table :data="tableData" style="width: 100%">
      <el-table-column prop="name" label="姓名" width="180"> </el-table-column>
      <el-table-column label="身份" width="180">
        <template slot-scope="scope">
          <span v-for="role in scope.row.roles" :key="role.id">
            {{ $t(role.name) }}
          </span>
        </template>
      </el-table-column>
      <el-table-column prop="identity" label="学号/工号"> </el-table-column>
      <el-table-column prop="createdAt" label="申请时间"> </el-table-column>
      <el-table-column label="操作">
        <template slot-scope="scope">
          <el-button
            type="danger"
            v-if="scope.row.isVerified === null"
            size="mini"
            @click="handlePass(scope.row)"
            >通过</el-button
          >
          <el-button
            type="info"
            v-if="scope.row.isVerified === null"
            size="mini"
            @click="handleNotPass(scope.row)"
            >禁止</el-button
          >
          <span v-if="scope.row.isVerified" style="color:#34394C;">已通过</span>
          <span v-if="scope.row.isVerified === false" style="color: #e72324;">
            已禁止
          </span>
          <el-button
            class="m-l-10"
            v-if="scope.row.isVerified === true"
            size="mini"
            plain
            @click="
              showResetDialog = true;
              accountData = scope.row;
            "
            >重置用户密码</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-dialog :visible="showResetDialog">
      <template v-if="accountData !== null">
        <el-form :model="accountData" :inline="true">
          <el-form-item class="fit" label="用户identity">
            <span>{{ accountData.identity }}</span>
          </el-form-item>
          <el-form-item class="fit" label="新密码">
            <el-input v-model="accountData.password" type="password"></el-input>
          </el-form-item>
        </el-form>
        <div class="button-group-container flex row content-start">
          <el-button type="success" @click="resetPass(accountData)" plain
            >确定</el-button
          >
          <el-button
            type="danger"
            @click="
              showResetDialog = false;
              accountData = null;
            "
            plain
            >取消</el-button
          >
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script>
export default {
  props: {
    tableData: {
      type: Array,
      default: () => []
    }
  },
  data() {
    return {
      showResetDialog: false,
      accountData: null
    };
  },
  methods: {
    handlePass(data) {
      this.$emit("pass", data);
    },
    handleNotPass(data) {
      this.$emit("unpass", data);
    },
    resetPass(data) {
      this.$emit("ressetPass", JSON.parse(JSON.stringify(data)));
      delete data.password;
      this.showResetDialog = false;
      this.accountData = null;
    }
  }
};
</script>

<style>
.el-tabs__nav {
  width: 100% !important;
}
.el-tabs__item {
  width: 51%;
  height: 50px;
}
.el-tabs__header .el-tabs__item.is-active,
.experiment-read .el-tabs__header .el-tabs__item.is-active:hover,
.experiment-read .el-tabs__item:hover {
  color: #e72324 !important;
}
</style>
